﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using System.Data.Linq;
using System.Linq;
using DA = HeuristicLab.Services.Hive.DataAccess;
using DT = HeuristicLab.Services.Hive.Common.DataTransfer;

namespace HeuristicLab.Services.OKB {
  public static class Convert {

   
    #region Job
    public static DT.Job ToDto(DA.Job source) {
      if (source == null) return null;
      return new DT.Job { Id = source.JobId };
    }
    public static DA.Job ToEntity(DT.Job source) {
      if (source == null) return null;
      return new DA.Job { JobId = source.Id };
    }
    public static void ToEntity(DT.Job source, DA.Job target) {
      if ((source != null) && (target != null)) {
        target.JobId = source.Id;
      }
    }
    #endregion



   
  }
}
