﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using HeuristicLab.Services.Hive.Common.ServiceContracts;
using HeuristicLab.Services.Hive.Common.DataTransfer;
using HeuristicLab.Hive.Contracts;
using System.IO;
using System.Security.Permissions;

namespace HeuristicLab.Services.Hive {
  /// <summary>
  /// Implementation of the Hive service (interface <see cref="IHiveService"/>).
  /// </summary>
  [ServiceBehavior(IncludeExceptionDetailInFaults = true)]
  public class HiveService : IHiveService {
    private DataAccess.IContextFactory contextFactory = new DataAccess.ContextFactory();

    #region Job Methods
    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Client)]
    public Guid AddJob(JobData dto) {
      using (contextFactory.GetContext()) {
        DataAccess.Job entity = Convert.ToEntity(dto); entity.Id = 0;
        okb.Platforms.InsertOnSubmit(entity);
        okb.SubmitChanges();
        return entity.Id;
      }
    }

    public Job AddJobWithGroupStrings(JobData jobObj, IEnumerable<string> groups) {
      throw new NotImplementedException();
    }

    public JobData GetLastSerializedResult(Guid jobId) {
      throw new NotImplementedException();
    }

    public void AbortJob(Guid jobId) {
      throw new NotImplementedException();
    }

    public Job GetJobById(Guid jobId) {
      throw new NotImplementedException();
    }

    public IEnumerable<LightweightJob> GetJobResults(IEnumerable<Guid> jobIds) {
      throw new NotImplementedException();
    }

    public IEnumerable<LightweightJob> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent) {
      throw new NotImplementedException();
    }

    public Job AddChildJob(Guid parentJobId, JobData serializedJob) {
      throw new NotImplementedException();
    }

    public Job GetAllJobsWithFilter(JobState jobState, int offset, int count) {
      throw new NotImplementedException();
    }

    public Job GetAllJobs() {
      throw new NotImplementedException();
    }

    public Job GetJobByIdWithDetails(Guid jobId) {
      throw new NotImplementedException();
    }

    public Job AddNewJob(JobData job) {
      throw new NotImplementedException();
    }

    public Job PauseJob(JobData serializedJob) {
      throw new NotImplementedException();
    }

    public void DeleteChildJobs(Guid jobId) {
      throw new NotImplementedException();
    }

    public Job GetJob(Guid clientId) {
      throw new NotImplementedException();
    }

    public void StoreFinishedJobResult(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception) {
      throw new NotImplementedException();
    }

    public void IsJobStillNeeded(Guid jobId) {
      throw new NotImplementedException();
    }

    public Stream GetStreamedJob(Guid clientId) {
      throw new NotImplementedException();
    }

    public void StoreFinishedJobResultStreamed(Stream stream) {
      throw new NotImplementedException();
    }

    #endregion

    #region HiveExperiment Methods
    public IEnumerable<HiveExperiment> GetHiveExperiments() {
      throw new NotImplementedException();
    }

    public HiveExperiment UpdateHiveExperiment(HiveExperiment hiveExperimentDto) {
      throw new NotImplementedException();
    }

    public void DeleteHiveExperiment(Guid hiveExperimentId) {
      throw new NotImplementedException();
    }
    #endregion

    #region Project Methods
    public Project GetAllProjects() {
      throw new NotImplementedException();
    }

    public void CreateProject(Project project) {
      throw new NotImplementedException();
    }

    public void ChangeProject(Project project) {
      throw new NotImplementedException();
    }

    public void DeleteProject(Guid projectId) {
      throw new NotImplementedException();
    }

    public IEnumerable<Job> GetJobsByProject(Guid projectId) {
      throw new NotImplementedException();
    }
    #endregion

    #region Login Methods
    public void Login() {
      throw new NotImplementedException();
    }

    public void Login(Slave slave) {
      throw new NotImplementedException();
    }

    public void Logout(Guid clientId) {
      throw new NotImplementedException();
    }
    #endregion

    #region Heartbeat Methods
    public List<MessageContainer> ProcessHeartBeat(HeartBeat hbData) {
      throw new NotImplementedException();
    }
    #endregion

    #region Plugin Methods
    public IEnumerable<HivePluginData> GetPlugins(List<HivePlugin> pluginList) {
      throw new NotImplementedException();
    }

    public System.IO.Stream GetStreamedPlugins(List<HivePlugin> pluginList) {
      throw new NotImplementedException();
    }
    #endregion

    #region Calendar Methods
    public IEnumerable<Appointment> GetCalendar(Guid clientId) {
      throw new NotImplementedException();
    }

    public void SetCalendarStatus(Guid clientId, CalendarState state) {
      throw new NotImplementedException();
    }

    public IEnumerable<Appointment> GetUptimeCalendarForResource(Guid guid) {
      throw new NotImplementedException();
    }

    public void SetUptimeCalendarForResource(Guid guid, IEnumerable<Appointment> appointments, bool isForced) {
      throw new NotImplementedException();
    }
    #endregion

    #region Slave Methods
    public IEnumerable<Slave> GetAllSlaves() {
      throw new NotImplementedException();
    }

    public IEnumerable<SlaveGroup> GetAllSlaveGroups() {
      throw new NotImplementedException();
    }

    public IEnumerable<SlaveGroup> GetAllGroupsOfResource(Guid resourceId) {
      throw new NotImplementedException();
    }

    public SlaveGroup AddSlaveGroup(SlaveGroup clientGroup) {
      throw new NotImplementedException();
    }

    public void DeleteSlaveGroup(Guid clientGroupId) {
      throw new NotImplementedException();
    }

    public void AddResourceToGroup(Guid clientGroupId, Resource resource) {
      throw new NotImplementedException();
    }

    public void DeleteResourceFromGroup(Guid clientGroupId, Guid resourceId) {
      throw new NotImplementedException();
    }
    #endregion

  }
}
