﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Runtime.Serialization;
using HeuristicLab.DataAccess;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {
  
  [StorableClass]
  [DataContract]
  public class AppointmentDto: PersistableObject {
    [Storable]
    [DataMember]
    public DateTime StartDate { get; set; }
    [Storable]
    [DataMember]
    public DateTime EndDate { get; set; }
    [Storable]
    [DataMember]
    public bool AllDayEvent { get; set; }
    [Storable]
    [DataMember]
    public bool Recurring { get; set; }
    [Storable]
    [DataMember]
    public Guid RecurringId { get; set; }
    [Storable]
    [DataMember]
    public Guid ResourceId { get; set; }

    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
      AppointmentDto clone = (AppointmentDto)base.Clone(cloner);
      clone.AllDayEvent = this.AllDayEvent;
      clone.EndDate = this.EndDate;
      clone.Recurring = this.Recurring;
      clone.RecurringId = this.RecurringId;
      clone.ResourceId = this.ResourceId;
      clone.StartDate = this.StartDate;
      return clone;
    }
  }
}
