﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Runtime.Serialization;
using HeuristicLab.DataAccess;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {

  [StorableClass]
  [DataContract]
  [Serializable]
  public class JobResult : PersistableObject {
    [Storable]
    [DataMember]
    public Guid SlaveId { get; set; }
    [Storable]
    [DataMember]
    public JobState State { get; set; }
    [Storable]
    [DataMember]
    public TimeSpan ExecutionTime { get; set; }
    [Storable]
    [DataMember]
    public String Exception { get; set; }
    [Storable]
    [DataMember]
    public DateTime? DateCreated { get; set; }
    [Storable]
    [DataMember]
    public DateTime? DateCalculated { get; set; }
    [Storable]
    [DataMember]
    public DateTime? DateFinished { get; set; }
    [Storable]
    [DataMember]
    public Guid? ParentJobId { get; set; }

    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
      JobResult clone = (JobResult) base.Clone(cloner);
      clone.SlaveId = this.SlaveId;
      clone.DateCreated = this.DateCreated;
      clone.DateCalculated = this.DateCalculated;
      clone.DateFinished = this.DateFinished;
      clone.Exception = this.Exception;
      clone.ExecutionTime = this.ExecutionTime;
      clone.State = this.State;
      clone.ParentJobId = this.ParentJobId;
      return clone;
    }
  }
}
